#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "warpi.h"
#include "wvarpi.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    //
    widht = ui->gView->width();
    height = ui->gView->height();
    //
    rszx    = 640;
    rszy    = 480;
    //
    scene               = new QGraphicsScene();
    pix                 = new QPixmap(widht,height);
    paint               = new QPainter(pix);
    int  cnt1, cnt2;
    //
    //
    ui->gView->setScene(scene);
    scene->addPixmap(*pix);
    //
    cnt1 = 0;
    while(cnt1 < rszy)
    {
        cnt2 = 0;
        while(cnt2 < rszx)
        {
            dpix[cnt2][cnt1] = 0;
            cnt2++;
        }
        cnt1++;
    }
    //
    valm1       = 0;
    valm2       = 0;
    valm3       = 0;
    valm4       = 0;
    wrvalm1     = 0;
    wrvalm2     = 0;
    wrvalm3     = 0;
    wrvalm4     = 0;
    wrhcam      = 0;
    wrvcam      = 0;
    hcam        = 0;
    vcam        = 0;
    connected   =   false;
    vconnected  =   false;
    cmd         = _cmd_stop;
    //
    ui->strIP->setText("192.168.7.1");
    ui->strPort->setText("8971");
    ui->vstrIP->setText("192.168.7.1");
    ui->vstrPort->setText("8998");
    //
    //fdraw();
    //
    tmr = new QTimer(this); // Создаем объект класса QTimer и передаем адрес переменной
    tmr->setInterval(500); // Задаем интервал таймера
    connect(tmr, SIGNAL(timeout()), this, SLOT(Vals())); // Подключаем сигнал таймера к нашему слоту
    tmr->start(0); // Запускаем таймер
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::paintEvent(QPaintEvent *event)
{
    int x,y;
    scene->clear();
    y = 0;
    while(y < rszy)
    {
        x = 0;
        while(x < rszx)
        {
            paint->setPen(QColor((dpix[x][y]),0,0));
            paint->drawPoint(x,y);
            x++;
        }
        y++;
    }
    scene->addPixmap(*pix);
}


void MainWindow::Vals(void)
{
    int val;
    //
    if((wCleintStatus() < 1) && (connected))
    {
        wDisconnect();
        connected = false;
    }
    //
    if((wVCleintStatus() < 1) && (vconnected))
    {
        wVDisconnect();
        vconnected = false;
    }
    if(!(vconnected))
    {
        ui->bvConnect->setText("Connect");
        ui->vstrIP->setEnabled(true);
        ui->vstrPort->setEnabled(true);
        ui->lsize->setText("Size = -------");
    }
    else
    {
        ui->bvConnect->setText("Disconnect");
        ui->vstrIP->setEnabled(false);
        ui->vstrPort->setEnabled(false);
        //
        wRdCam((unsigned char*)(&dpix[0][0]));
        ui->lsize->setText("Size = " + QString::number(rszx) + "x" + QString::number(rszy));
    }
    ui->ltmark->setText("Time Mark = " + QString::number(rtmark));
    //
    if(!(connected))
    {
        ui->bConnect->setText("Connect");
        ui->b_stop->setEnabled(false);//test();
        ui->b_forward->setEnabled(false);
        ui->b_backward->setEnabled(false);
        ui->b_left->setEnabled(false);
        ui->b_right->setEnabled(false);
        ui->sl_speed->setEnabled(false);
        ui->progressBar_m1->setEnabled(false);
        ui->progressBar_m2->setEnabled(false);
        ui->progressBar_m3->setEnabled(false);
        ui->progressBar_m4->setEnabled(false);
        ui->strIP->setEnabled(true);
        ui->strPort->setEnabled(true);
        ui->pServNull->setEnabled((false));
        ui->hcam->setEnabled(false);
        ui->vcam->setEnabled(false);
    }
    else
    {
        ui->bConnect->setText("Disconnect");
        ui->b_stop->setEnabled(true);
        ui->b_forward->setEnabled(true);
        ui->b_backward->setEnabled(true);
        ui->b_left->setEnabled(true);
        ui->b_right->setEnabled(true);
        ui->sl_speed->setEnabled(true);
        ui->progressBar_m1->setEnabled(true);
        ui->progressBar_m2->setEnabled(true);
        ui->progressBar_m3->setEnabled(true);
        ui->progressBar_m4->setEnabled(true);
        ui->strIP->setEnabled(false);
        ui->strPort->setEnabled(false);
        ui->pServNull->setEnabled((true));
        ui->hcam->setEnabled(true);
        ui->vcam->setEnabled(true);
    }
    //
    switch(cmd)
    {
        case _cmd_forward:
            val = ui->sl_speed->value();
            wrvalm1 = val;
            wrvalm2 = val;
            wrvalm3 = val;
            wrvalm4 = val;
            ui->label_cmd->setText("FORWARD");
            break;
        case _cmd_backward:
            val = ui->sl_speed->value();
            wrvalm1 = val * (-1);
            wrvalm2 = val * (-1);
            wrvalm3 = val * (-1);
            wrvalm4 = val * (-1);
            ui->label_cmd->setText("BACWARD");
            break;
        case _cmd_left:
            val = ui->sl_speed->value();
            wrvalm1 = val * (-1);
            wrvalm2 = val;
            wrvalm3 = val * (-1);
            wrvalm4 = val;
            ui->label_cmd->setText("LEFT");
            break;
        case _cmd_right:
            val = ui->sl_speed->value();
            wrvalm1 = val;
            wrvalm2 = val * (-1);
            wrvalm3 = val;
            wrvalm4 = val * (-1);
            ui->label_cmd->setText("RIGHT");
            break;
        default:
            wrvalm1 = 0;
            wrvalm2 = 0;
            wrvalm3 = 0;
            wrvalm4 = 0;
            cmd = _cmd_stop;
            ui->label_cmd->setText("STOP");
            break;
    }
    //
    valm1   = (100.0 / 255.0) * wRdReg(_num_vol_m1);
    valm2   = (100.0 / 255.0) * wRdReg(_num_vol_m2);
    valm3   = (100.0 / 255.0) * wRdReg(_num_vol_m3);
    valm4   = (100.0 / 255.0) * wRdReg(_num_vol_m4);
    hcam    = wRdReg(_num_pos_s1);
    vcam    = wRdReg(_num_pos_s2);
    //
    wWrReg(_num_vol_m1, wrvalm1);
    wWrReg(_num_vol_m2, wrvalm2);
    wWrReg(_num_vol_m3, wrvalm3);
    wWrReg(_num_vol_m4, wrvalm4);
    //
    wrhcam = (ui->hcam->value()) * (-1);
    wrvcam = ui->vcam->value();
    //
    wWrReg(_num_pos_s1, wrhcam);
    wWrReg(_num_pos_s2, wrvcam);
    //
    if(valm1 > 0)
        ui->progressBar_m1->setStyleSheet("background-color: lightgreen;");
    else if(valm1 == 0)
        ui->progressBar_m1->setStyleSheet("background-color: lightgray;");
    else
        ui->progressBar_m1->setStyleSheet("background-color: red;");
    if(valm2 > 0)
        ui->progressBar_m2->setStyleSheet("background-color: lightgreen;");
    else if(valm2 == 0)
        ui->progressBar_m2->setStyleSheet("background-color: lightgray;");
    else
        ui->progressBar_m2->setStyleSheet("background-color: red;");
    if(valm3 > 0)
        ui->progressBar_m3->setStyleSheet("background-color: lightgreen;");
    else if(valm3 == 0)
        ui->progressBar_m3->setStyleSheet("background-color: lightgray;");
    else
        ui->progressBar_m3->setStyleSheet("background-color: red;");
    if(valm4 > 0)
        ui->progressBar_m4->setStyleSheet("background-color: lightgreen;");
    else if(valm4 == 0)
        ui->progressBar_m4->setStyleSheet("background-color: lightgray;");
    else
        ui->progressBar_m4->setStyleSheet("background-color: red;");
    //
    ui->progressBar_m1->setValue(abs(valm1));
    ui->progressBar_m2->setValue(abs(valm2));
    ui->progressBar_m3->setValue(abs(valm3));
    ui->progressBar_m4->setValue(abs(valm4));
    //
    ui->lhpos->setText(QString::number(hcam));
    ui->lvpos->setText(QString::number(vcam));
}

void MainWindow::on_b_forward_clicked()
{
    cmd = _cmd_forward;
}

void MainWindow::on_b_stop_clicked()
{
    ui->sl_speed->setValue(0);
    cmd = _cmd_stop;
}

void MainWindow::on_b_backward_clicked()
{
    cmd = _cmd_backward;
}

void MainWindow::on_b_left_clicked()
{
    cmd = _cmd_left;
}

void MainWindow::on_b_right_clicked()
{
    cmd = _cmd_right;
}

//связь с сервером управления
void MainWindow::on_bConnect_clicked()
{
    QString qstrip      = ui->strIP->text();
    QString qstrport    = ui->strPort->text();
    QByteArray arip, arport;
    char * strip;
    char * strport;
    int port;
    int res;
    if(!(connected))
    {
        arip                = qstrip.toAscii().data();
        arport              = qstrport.toAscii().data();
        strip               = arip.data();
        strport             = arport.data();
        //
        port                = atoi(&strport[0]);
        res = wConnect(&strip[0], port);
        if(res == 0)
            connected = true;
    }
    else
    {
        wDisconnect();
        connected = false;
    }
}

void MainWindow::on_pServNull_clicked()
{
    ui->hcam->setValue(0);
    ui->vcam->setValue(0);
}

void MainWindow::on_bvConnect_clicked()
{
    QString qstrip      = ui->vstrIP->text();
    QString qstrport    = ui->vstrPort->text();
    QByteArray arip, arport;
    char * strip;
    char * strport;
    int port;
    int res;
    if(!(vconnected))
    {
        arip                = qstrip.toAscii().data();
        arport              = qstrport.toAscii().data();
        strip               = arip.data();
        strport             = arport.data();
        //
        port                = atoi(&strport[0]);
        res = wVConnect(&strip[0], port);
        if(res == 0)
            vconnected = true;
    }
    else
    {
        wVDisconnect();
        vconnected = false;
    }
}
