#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>
#include <pthread.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include "types.h"
#include "wvarpi.h"

cvCLIENT	vcclient;

struct  sockaddr_in     vccaddr;
pthread_t               hvClientProcess;
pthread_mutex_t         vClientMutex;
int                     vClientWork;

U8  vbuf[640][480];
//
int rszx;
int rszy;
int rtmark;

//
U16 szx;
U16 szy;
U16 tmark;


int wVConnect(char* ipaddr, int port)
{
    struct  hostent *ht;
    pthread_attr_t 	tattr;
    //параметры для отделяемых потоков
    pthread_attr_init(&tattr);
    pthread_attr_setdetachstate(&tattr, PTHREAD_CREATE_DETACHED);
    //
    vcclient.socket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    //
    if(vcclient.socket < 0)
        return 1;
    vccaddr.sin_family = AF_INET;
    vccaddr.sin_port = htons(port);
    ht = gethostbyname((char*)(ipaddr));
    vccaddr.sin_addr.s_addr = *(ulong*)(ht->h_addr_list[0]);
    memset(&vccaddr.sin_zero, 0, 8);
    //
    if(connect(vcclient.socket, (struct sockaddr *)&vccaddr, sizeof(vccaddr)) < 0)
        return 2;
    //mutex create
    if(!(pthread_mutex_init(&vClientMutex,NULL) == 0))
    {
        close(vcclient.socket);
        return 3;
    }
    pthread_create(&hvClientProcess, &tattr, vclient_process, NULL);
    vClientWork = 1; //установка флага работы
    return 0;
}

int wVDisconnect(void)
{
    vClientWork = 0;
    sleep(1);
    //pthread_mutex_lock(&ClientMutex);
    close(vcclient.socket);
    //pthread_mutex_unlock(&ClientMutex);

    return 0;
}


inline int cvReadSocket(int nSocket, BYTE *pBuffer)
{
        //int     res                     = 1;
        int     	iRC                     = 0;
        int     	iReceiveStatus          = 0;
        int     	iStillToReceive         = 4; //начальный размер получения минимальных данных
        int     	iCount 	= 0;
        int		sz	= 0;
        struct timeval 	ReceiveTimeout;
        fd_set 		fds;
        U8		flag			= 0;
        //fcntl(nSocket, F_SETFL, O_NONBLOCK);
        //fds = calloc(1, sizeof(fd_set));// fds;
        //int size = 0;
        while(iStillToReceive > 0)
        {
                 //установка величины таймаута
                FD_ZERO(&fds);
                FD_SET(nSocket, &fds);
                ReceiveTimeout.tv_sec  = 0;
                ReceiveTimeout.tv_usec = _SOCKET_TIMEOUT_;
                iRC = select(nSocket + 1, &fds, NULL, NULL, &ReceiveTimeout);
                //выход по таймауту
                if(!iRC)
            return -1;
        //произошла какая то ошибка
                if(iRC < 0)
                        return -2;
        //ошибка указания размера данных
                if(iStillToReceive <= 0)
                        return -3;
                //прием нескольких байт
        #if(_tcp_recv_deb == 1)
            printf("----read sock (recv) ----\r\n");
            #endif
                iReceiveStatus = recv(nSocket, (char*)(pBuffer), iStillToReceive, 0);
                if(iReceiveStatus >  0)
                {
                    pBuffer += iReceiveStatus;
                    iStillToReceive -= iReceiveStatus;
                    iCount += iReceiveStatus;
                    if((iCount >= 4) && (flag == 0))
                    {
                        //iStillToReceive = (*(U16*)(pBuffer - iCount)) - iCount;
                        sz		= (*(U32*)(pBuffer - iCount));
                        iStillToReceive = sz - iCount;
                        flag = 0xFF;
                    }
                }
        else if(iReceiveStatus == 0)
            return -1;
        else
            return -2;
        #if(_tcp_recv_deb == 1)
            printf("==iStillToReceive:%i iCount:%i==\r\n", iStillToReceive, iCount);
        #endif
        }
    //дополнительная проверка размера
    if(sz != iCount)
        return -3;
        //
        return iCount;
}


inline int cvWriteSocket(int nSocket, BYTE *pBuffer, U32 iMessageLength)
{
    int 		iCount		= 0;
        int 		iSC 		= 0;
        int 		iSendStatus 	= 0;
        struct timeval 	SendTimeout;
        fd_set 		fds;
    //fcntl(nSocket, F_SETFL, O_NONBLOCK);
        while(iMessageLength > 0)
        {
        //установка величины таймаута
            SendTimeout.tv_sec  = 0;
            SendTimeout.tv_usec = _SOCKET_TIMEOUT_;
            FD_ZERO(&fds);
            FD_SET(nSocket, &fds);
                iSC = select(nSocket + 1, NULL, &fds, NULL, &SendTimeout);
                if(!iSC)
                        return -1; //таймаут
                if(iSC < 0)
                        return -2; //ошибка
        //отправить несколько байт
        #if(_tcp_send_deb == 1)
            printf("----write sock (send) ----\r\n");
                #endif
        iSendStatus = send(nSocket, (char*)(pBuffer), iMessageLength, 0);
                if(iSendStatus > 0)
                {
                        //обновить буфер и счетчик
                        iMessageLength -= iSendStatus;
                        pBuffer += iSendStatus;
                        iCount += iSendStatus;
                }
        else if(iSendStatus == 0)
            return -1;
        else
            return -2;
        }
    return iCount;
}

static void*  vclient_process(void * pr)
{
    U8	txbuf[_vsize_buf];
    U8	rxbuf[_vsize_buf];
    U32	txsz = 0;
    U32 cntx, cnty, cntbyte;
    int	res;
    //
    while(vClientWork)
    {
        pthread_mutex_lock(&vClientMutex);
        //формирование запроса
        memset(&txbuf[0], 0, _vsize_buf);
        txbuf[_vtype]   = _vtype_scr8;
        txbuf[_vcop]    = _vcop_rd;
        txsz = 16;
        (*(U32*)(&txbuf[_vtcp_szl])) = txsz;
        //передача данных
        if(txsz > 0)
        {
            res = cvWriteSocket(vcclient.socket, &txbuf[0], txsz);
            switch(res)
            {
                case -2:
                    vClientWork = 0;
                    break;
                case 0:		//
                    break;
                default:
                    break;
            }
        }
        //usleep(_vconn_sleep);
        res = cvReadSocket(vcclient.socket, &rxbuf[0]);
        //приём данных
        switch(res)
        {
            case 0:	//Ok
                //countlive = setcntlive;
                //mworkr(&rxbuf[0]);
                break;
            case -1: //таймаут
                #if(_deb == 1)
                    printf("TCP client recv. timeout..\r\n");
                #endif
                break;
            case -2: //какая-то ошибка сокета
                #if(_deb == 1)
                    printf("TCP client resv. err?..\r\n");
                #endif
                goto mexit;
            case -3: //ошибка размера пакета
                //передача сообщения о несоответствии
                #if(_deb == 1)
                    printf("TCP client frame no correct..\r\n");
                #endif
                goto mexit; //отмена обработки запроса
            default: //нормально - данные приняты
                //обработка ответа
                tmark   = (*(U16*)(&rxbuf[_mtime]));
                szx     = (*(U16*)(&rxbuf[_vwidht]));
                szy     = (*(U16*)(&rxbuf[_vheight]));
                //memcpy(&vbuf[0], &rxbuf[_vdaddr], szx * szy);
                cnty = 0;
                cntbyte = 0;
                while(cnty < szy)
                {
                    cntx = 0;
                    while(cntx < szx)
                    {
                        vbuf[cntx][cnty] = rxbuf[_vheight + cntbyte];
                        cntbyte++;
                        cntx++;
                    }
                    cnty++;
                }
                break;
        }
        pthread_mutex_unlock(&vClientMutex);
        //
        usleep(_vconn_sleep);
    }
mexit:	close(vcclient.socket);
    vClientWork = 0;
    pthread_mutex_unlock(&vClientMutex);
    //
    pthread_exit(0);
}

//чтение статуса связи
int wVCleintStatus(void)
{
    return vClientWork;
}

//чтение значения регистров
I16 wRdCam(U8 * scr)
{
    //int cntx,cnty;
    pthread_mutex_lock(&vClientMutex);
    rszx    = (int)(szx);
    rszy    = (int)(szy);
    rtmark  = (int)(tmark);
    memcpy(scr, &vbuf[0][0], rszx * rszy);
    pthread_mutex_unlock(&vClientMutex);
    return 0;
}
